#{extends 'common/frontend-admin.html' /}
#{set 'title'}
<h1>#{if model.isCreatedMode() }Tambah Tableau Library #{/if} #{else } Edit Tableau Library#{/else}</h1>
#{/set}
<div class="container">
    <div class="row">
        <div class="col-sm-10">
            <div class="card">
                #{common.alert /}
                <div class="card-header">
                    Form Input Tableau Library
                </div>
                <div class="card-body">
                    <form class="form-input-tableau" action="@{store()}" method="post">
                        <input type="hidden" name="model.action" value="${model?.action}" >
                        <input type="hidden" name="model.id" value="${model?.id}" >
                        <div class="form-group">
                            <label for="model.title" class="col-sm-2 control-label">Title Content</label>
                            <div class="col-md-12 #{errorClass 'model.title'/}">
                                <input type="text" name="model.title" id="model.title" required placeholder="Title" value="${model?.title}" class="form-control">
                                <span class="help-block">#{error 'model.title' /}</span>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="model.uri" class="col-sm-2 control-label">URI</label>
                            <div class="col-md-12 #{errorClass 'model.content'/}">
                                <input type="text" name="model.uri" id="model.uri" placeholder="URI" required value="${model?.uri}" class="form-control">
                                <span class="help-block">#{error 'model.uri' /}</span>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="model.description" class="col-sm-2 control-label">Description</label>
                            <div class="col-md-12 #{errorClass 'model.content'/}">
                                <textarea name="model.description" id="model.description" placeholder="Description" class="form-control">${model?.description}</textarea>
                                <span class="help-block">#{error 'model.description' /}</span>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="checkbox check-success mar-l-checkbox">
                                <input id="checkbox2" name="model.availableForKldi" type="checkbox" ${model?.availableForKldi ? "checked" : ""} >
                                <label for="checkbox2">Tersedia untuk KLPD</label>
                            </div>
                        </div>
                        <label class="control-label col-md-12">Parameters</label>
                        <div class="param-container">
                            <div class="alert alert-danger" style="display: none">
                                Belum memiliki parameter!
                            </div>
                            #{list items:model?.params , as:'param'}
                                <div class="form-row">
                                    <div class="form-group col-md-4">
                                        <label for="model.uri" class="control-label">Label</label>
                                        <input type="text" name="${param.key}.label" placeholder="Label" required value="${param?.value?.label}" class="form-control">
                                    </div>
                                    <div class="form-group col-md-6">
                                        <label for="model.uri" class="control-label">Value <span class="text-danger">(*)</span></label>
                                        <input type="text" data-role="tagsinput" name="${param.key}.value" required value="${param?.value?.value}" class="form-control tag-values">
                                    </div>
                                    <div class="form-group col-md-2">
                                        <label class="control-label">Hapus Parameter</label>
                                        <br />
                                        <div class="btn-group col-md-12">
                                            <button type="button" class="remove-param btn btn-complete"><i class="fa fa-trash"></i></button>
                                        </div>
                                    </div>
                                </div>
                            #{/list}
                            <br class="spacer" />
                            <div class="form-row">
                                <div class="form-group col-md-4">
                                </div>
                                <div class="form-group col-md-6">
                                </div>
                                <div class="form-group col-md-2">
                                    <label class="control-label">Tambah Parameter</label>
                                    <div class="btn-group col-md-12" >
                                        <button type="button" class="add-param btn btn-complete"><i class="fa fa-plus"></i></button>
                                    </div>
                                </div>
                            </div>
                            <br />
                            <p> <span class="text-danger">(*)</span> Anda dapat memasukkan lebih dari satu nilai dengan pimisah koma(,)</p>
                        </div>
                        <br />
                        <div class="form-group">
                            <div class="col-sm-12">
                                <div class="pull-right">
                                    <button type="button" class="btn btn-success save-button">Save</button>
                                    <a href='@{index()}' class="btn btn-default">Back</a>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
#{set 'moreScripts'}
<script type="text/javascript" src="@{'/public/javascripts/bootstrap-tagsinput.min.js'}"></script>
<script type="text/javascript">
    $(document).ready(function() {
        $(document).on('click', '.remove-param', function() {
            $(this).parent().parent().parent().remove()
        })
        // https://stackoverflow.com/a/21963136
        function broofa() {
            return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
                var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
                return v.toString(16);
            });
        }

        let helpBlock = (e) => [...$(e).siblings()].find(s => s.className === 'help-block')
        let setHelpBlock = (e, message) => {
            console.log(e)
            let help = helpBlock(e)
            if (help) {
                $(help).html(message)
            }
        }
        $(document).on('blur', '.form-input-tableau input[type="text"]', function(e) {
            let target = e.target
            if (!target) {
                return
            }
            let value = target.value
            let parentElement = $(target).parent()
            if (parentElement.hasClass('bootstrap-tagsinput')) {
                target = parentElement
                value = parentElement.children().length > 1
                parentElement = parentElement.parent()
            }
            if (!value) {
                return
            }
            parentElement.removeClass('has-error')
            setHelpBlock(target, '')
        })

        let toggleParamAlert = (status) => {
            if (!status) {
                $('.param-container .alert').show()
            } else {
                $('.param-container .alert').hide()
            }
        }

        let validateParams = () => {
            let status = $('.param-container input[type="text"]').length > 0
            toggleParamAlert(status)
            return status
        }

        let validateInputTextHasError = () => {
            let elements = $('.form-input-tableau input[type="text"]')
            let total = 0
            elements.each((i, e) => {
                if (e.getAttribute('name') && !e.value) {
                    $(e).parent().addClass('has-error')
                    setHelpBlock(e, 'Masih kosong!')
                    total++
                }
            })
            return total
        }

        $('.save-button').click(function(e) {
            e.preventDefault()
            if (validateInputTextHasError() > 0) {
                return
            }
            if (!validateParams()) {
                return
            }
            $('.form-input-tableau').submit()
        })

        $('.add-param').click(function() {
            toggleParamAlert(true)
            var unique = broofa();
            var template = '<div class="form-row">' +
                                '<div class="form-group col-md-4">' +
                                    '<label class="control-label">Label</label>' +
                                    '<input type="text" name="model.params.' + unique+ '.label" placeholder="Label" required class="form-control">' +
                                    '<span class="help-block"></span>' +
                                '</div>' +
                                '<div class="form-group col-md-6">' +
                                    '<label class="control-label">Value <span class="text-danger">(*)</span></label>' +
                                    '<input type="text" data-role="tagsinput" value="" name="model.params.' + unique+ '.value" required class="form-control tag-values">' +
                                    '<span class="help-block"></span>' +
                                '</div>' +
                                '<div class="form-group col-md-2">' +
                                    '<label class="control-label">Hapus Parameter</label>' +
                                    '<br />' +
                                    '<div class="btn-group col-md-12">' +
                                        '<button type="button" class="remove-param btn btn-complete"><i class="fa fa-trash"></i></button>' +
                                    '</div>' +
                                '</div>' +
                            '</div>'
            $('.spacer').before(template)
            $('.tag-values').tagsinput();
        })
    })
</script>
#{/set}